#include "ether.h"
#include "det.h"
#include "installer.h"

#define ETHERNET_NETWORK_CARD 0x0200

struct tgt_object *line, *list, *label1, *label2, *label3, *label4, *label5,
		 *string1, *string2, *string3, *string4, *string5, *b1, *b2, *b3,
		 *eth_window, *eth_label1, *eth_label2, *eth_label3, *eth_label4,
		 *eth_string1, *eth_string2, *eth_string3, *eth_b1, *eth_b2, *eth_select1,
		 *dnscheckb, *gwcheckb, *eth_checkb;

int ethercount, selectedether, eth_modulen, b=1;
char *dns_1, *dns_2, *dns_3, *gateway_1, set_up[50];
char eth_name[100], eth_ip[16], eth_netmask[16], eth_module[16];
char *selectedether_ip, *selectedether_netmask, *selectedether_gateway, *hostname;
struct pci_device_array ethdevice[10];
struct eth_card ether[10];
int user_main();
int ldap_main();
int preinst1_main();

void eth_prev() {
	
	tgt_unlink(window);
	user_main();
	tgt_refresh(window);
		
}

void eth_next() {
	
	tgt_unlink(window);
	if (!server_edition) { preinst1_main(); }
	else { ldap_main(); }
	tgt_refresh(window);
}

void save_eth() {
	    char tmp[200], tmp2[200];
		int i,d;		

		conf = tgt_load_conf(confile);
		
		tgt_get(string1,TGTT_STRING_STRING,(tgtt*) &dns_1);		
		tgt_get(string2,TGTT_STRING_STRING,(tgtt*) &dns_2);		
		tgt_get(string3,TGTT_STRING_STRING,(tgtt*) &dns_3);		
		tgt_get(string5,TGTT_STRING_STRING,(tgtt*) &hostname);		
		tgt_get(dnscheckb,TGTT_CHECKBOX_ACTIVE,(tgtt *) &d);
				
			    
	     if (d == 1) {		
		 tgt_set_conf(conf,"eth","dns1",dns_1);
		 tgt_set_conf(conf,"eth","dns2",dns_2);
		 if (strlen(dns_3) != 0) { tgt_set_conf(conf,"eth","dns3",dns_3); }
		}
							
		for(i = 0; i<ethercount; i++) { 
		sprintf(tmp,"eth%d",i);
		 
		 if ( !ether[i].dhcp ) {
		  sprintf(tmp2,"%s,%s,%s,%s",ethdevice[i].module,ether[i].ip,ether[i].netmask,ether[i].gateway);
		 } else { 
		  sprintf(tmp2,"%s,dhcp,%s",ethdevice[i].module,ether[i].gateway);
		 }
		 
		tgt_set_conf(conf,"eth",tmp,tmp2);
		}
		
		tgt_set_conf(conf,"eth","hostname",hostname);
		
		tgt_save_conf(conf,confile);
						
		eth_next();

}

int listfill(void **d, int c, int n, char *tmp, int k, int a) {

	if(c == TGT_LISTREQ_GETMAX) {
	 return(ethercount);

	} else {
	 snprintf(tmp,k,ethdevice[n].name,ethdevice[ethercount].name);
	 if ( a == 1 ) { selectedether = n; }
	}

	return(1);
}

void dnscheck() {

	int c;

	tgt_get(dnscheckb,TGTT_CHECKBOX_ACTIVE,(tgtt *) &c);
	if (c == 1) {
		tgt_make_selectable(string1);
		tgt_make_selectable(string2);
		tgt_make_selectable(string3);
		tgt_refresh(string1);
		tgt_refresh(string2);
		tgt_refresh(string3);
	}
	else{
		tgt_make_nonselectable(string1);
		tgt_make_nonselectable(string2);
		tgt_make_nonselectable(string3);
		tgt_refresh(string1);
		tgt_refresh(string2);
		tgt_refresh(string3);
	}

}

void gwcheck() {

	int c;

	tgt_get(gwcheckb,TGTT_CHECKBOX_ACTIVE,(tgtt *) &c);
	if (c == 1) {
		tgt_make_selectable(eth_string3);
		tgt_refresh(eth_string3);
	}
	else{
		tgt_make_nonselectable(eth_string3);
		tgt_refresh(eth_string3);
	}

}

void eth_check() {

	tgt_get(eth_checkb,TGTT_CHECKBOX_ACTIVE,(tgtt *) &ether[selectedether].dhcp);
	if (ether[selectedether].dhcp == 1) {
		tgt_make_nonselectable(eth_string1);
		tgt_make_nonselectable(eth_string2);
		tgt_refresh(eth_string1);
		tgt_refresh(eth_string2);
	}
	else{
		tgt_make_selectable(eth_string1);
		tgt_make_selectable(eth_string2);
		tgt_refresh(eth_string1);
		tgt_refresh(eth_string2);
	}

}

void eth_window_quit() {

	tgt_unlink(eth_window);
	tgt_refresh(window);

}

void eth_window_save() {

	int c, blind='\0';

	tgt_get(eth_string1,TGTT_STRING_STRING,(tgtt*) &selectedether_ip);
	tgt_get(eth_string2,TGTT_STRING_STRING,(tgtt*) &selectedether_netmask);
	tgt_get(eth_string3,TGTT_STRING_STRING,(tgtt*) &selectedether_gateway);
	sprintf(ether[selectedether].ip, "%s", selectedether_ip);
	sprintf(ether[selectedether].netmask, "%s", selectedether_netmask);
	

	tgt_get(eth_checkb,TGTT_CHECKBOX_ACTIVE,(tgtt *) &c);
	ether[selectedether].dhcp=c;

	if (ether[selectedether].dhcp == 1) {
		sprintf(ether[selectedether].ip, "%c", blind);
		sprintf(ether[selectedether].netmask, "%c", blind);
	}
	
	tgt_get(gwcheckb,TGTT_CHECKBOX_ACTIVE,(tgtt *) &c);
	if ( c == 1 ) { sprintf(ether[selectedether].gateway, "%s", selectedether_gateway); }
	
	tgt_unlink(eth_window);
	tgt_refresh(window);

}

void set_ethercard_window() {

	sprintf(eth_name, "eth%1d - %s", selectedether, ethdevice[selectedether].name);
	sprintf(eth_ip, "%s", ether[selectedether].ip);
	sprintf(eth_netmask, "%s", ether[selectedether].netmask);
	sprintf(eth_module, "%s", ethdevice[selectedether].module);
	eth_modulen=ether[selectedether].modulen;
	
	eth_window = tgt_createobject(
	TGT_CLASS_WINDOW, (tgtt[]) {
	TGTT_WINDOW_TITLE, (tgtt) "Ethernet krtya belltsa",
	TGTT_WINDOW_TITLECOLOR,3,
	TGTT_WINDOW_BORDERCOLOR,3,
	TGTT_CALLBACK, (tgtt) hotkeys,
	TGTT_XS, 55, TGTT_YS, 14,	
	TGTT_END,0 
	});

	tgt_set(eth_window, TGTT_X, (tgt_getterminal()->x_size - 55) / 2);
	tgt_set(eth_window, TGTT_Y, (tgt_getterminal()->y_size - 14) / 2);	

	tgt_link(eth_window,desktop);

	eth_label1 = tgt_createandlink(eth_window,TGT_CLASS_LABEL,
	(tgtt[]) {TGTT_X,2,TGTT_Y,2,
	TGTT_LABEL_TEXT, (tgtt) eth_name,
	TGTT_END,0});

	eth_checkb = tgt_createandlink(eth_window,TGT_CLASS_CHECKBOX,
	(tgtt[]) {TGTT_X,2,TGTT_Y,4,
	TGTT_CHECKBOX_CAPTION, (tgtt) "DHCP hasznalata",
	TGTT_CALLBACK, (tgtt) eth_check,
	TGTT_END,0});

	if (ether[selectedether].dhcp == 1){
		tgt_set(eth_checkb,TGTT_CHECKBOX_ACTIVE, ether[selectedether].dhcp);
		tgt_refresh(eth_checkb);
	}

	eth_label3 = tgt_createandlink(eth_window,TGT_CLASS_LABEL,(tgtt[]) {
	TGTT_X,2,TGTT_Y,5,
	TGTT_LABEL_TEXT, (tgtt) "IP cim: ",
	TGTT_END,0
	});

	eth_string1 = tgt_createandlink(eth_window,TGT_CLASS_STRING,(tagitem[]) {
	TGTT_X,18,TGTT_Y,5,TGTT_XS,16,
	TGTT_STRING_MAX,16,
	TGTT_STRING_ACCEPT, (tgtt) "0123456789.",
	TGTT_STRING_STRING, (tgtt) eth_ip,
	TGTT_CALLBACK,(tgtt) nextitem,
	TGTT_END,0	
	});

	if (ether[selectedether].dhcp == 1){
		tgt_make_nonselectable(eth_string1);
		tgt_refresh(eth_string1);
	}

	eth_label4 = tgt_createandlink(eth_window,TGT_CLASS_LABEL,(tgtt[]) {
	TGTT_X,2,TGTT_Y,6,
	TGTT_LABEL_TEXT, (tgtt) "Netmask: ",
	TGTT_END,0
	});

	eth_string2 = tgt_createandlink(eth_window,TGT_CLASS_STRING,(tagitem[]) {
	TGTT_X,18,TGTT_Y,6,TGTT_XS,16,
	TGTT_STRING_MAX,16,
	TGTT_STRING_ACCEPT, (tgtt) "0123456789.",
	TGTT_STRING_STRING, (tgtt) eth_netmask,
	TGTT_CALLBACK,(tgtt) nextitem,
	TGTT_END,0	
	});

	if (ether[selectedether].dhcp == 1){
		tgt_make_nonselectable(eth_string2);
		tgt_refresh(eth_string2);
	}
	
	gwcheckb = tgt_createandlink(eth_window,TGT_CLASS_CHECKBOX,
	(tgtt[]) {TGTT_X,2,TGTT_Y,8,
	TGTT_CHECKBOX_CAPTION, (tgtt) "Atjr kzi belltsa",
	TGTT_CHECKBOX_ACTIVE,0,
	TGTT_CALLBACK, (tgtt) gwcheck,
	TGTT_END,0});

	label4 = tgt_createandlink(eth_window,TGT_CLASS_LABEL,(tgtt[]) {
	TGTT_X,2,TGTT_Y,9,
	TGTT_LABEL_TEXT, (tgtt) "Atjr: ",
	TGTT_END,0
	});

	eth_string3 = tgt_createandlink(eth_window,TGT_CLASS_STRING,(tagitem[]) {
	TGTT_X,18,TGTT_Y,9,TGTT_XS,16,
	TGTT_STRING_MAX,16,
	TGTT_STRING_ACCEPT, (tgtt) "0123456789.",
	TGTT_CALLBACK,(tgtt) nextitem,
	TGTT_END,0	
	});

	tgt_make_nonselectable(eth_string3);
	tgt_refresh(eth_string3);

	line = tgt_createandlink(eth_window,TGT_CLASS_LABEL,
	(tgtt[]) {TGTT_X,1,TGTT_Y,11,
	TGTT_LABEL_TEXT, (tgtt) "-----------------------------------------------------",	
	TGTT_END,0});
	
	eth_b2 = tgt_createandlink(eth_window,TGT_CLASS_BUTTON,(tgtt[]) {
	TGTT_X,35,TGTT_Y,12,
	TGTT_BUTTON_CAPTION, (tgtt) "  Ok  ",
	TGTT_CALLBACK, (tgtt) eth_window_save,
	TGTT_BG,1,
	TGTT_END });
	
	eth_b1 = tgt_createandlink(eth_window,TGT_CLASS_BUTTON,(tgtt[]) {
	TGTT_X,12,TGTT_Y,12,
	TGTT_BUTTON_CAPTION, (tgtt) " Megse ",
	TGTT_CALLBACK, (tgtt) eth_window_quit,
	TGTT_BG,1,
	TGTT_END });	

	tgt_setfocus(eth_window);
	tgt_refresh(window);

}

void step_eth()
{
	window = tgt_createobject(
	TGT_CLASS_WINDOW, (tgtt[]) {
	TGTT_WINDOW_TITLE, (tgtt) "UHU LINUX - Hlzat belltsa",
	TGTT_WINDOW_TITLECOLOR,3,
	TGTT_WINDOW_BORDERCOLOR,3,
	TGTT_CALLBACK, (tgtt) hotkeys,
	TGTT_XS, 78, TGTT_YS, 23,	
	TGTT_END,0 
	});

	tgt_set(window, TGTT_X, (tgt_getterminal()->x_size - 78) / 2);
	tgt_set(window, TGTT_Y, (tgt_getterminal()->y_size - 23) / 2);	
	
	tgt_link(window,desktop);
	
	list = tgt_createandlink(window,TGT_CLASS_LIST,(tgtt[]) {
	TGTT_X,2,TGTT_Y,2,
	TGTT_XS,74,TGTT_YS,7,
	TGTT_LIST_ACTIVEBG,1,
	TGTT_LIST_FRAMECOLOR,3,
	TGTT_ID,1000,
	TGTT_LIST_DATACALLBACK, (tgtt) listfill,
	TGTT_CALLBACK, (tgtt) set_ethercard_window,
	TGTT_END,0
	});

	dnscheckb = tgt_createandlink(window,TGT_CLASS_CHECKBOX,
	(tgtt[]) {TGTT_X,13,TGTT_Y,10,
	TGTT_CHECKBOX_CAPTION, (tgtt) "DNS kzi belltsa",
	TGTT_CHECKBOX_ACTIVE,0,
	TGTT_CALLBACK, (tgtt) dnscheck,
	TGTT_END,0});

	label1 = tgt_createandlink(window,TGT_CLASS_LABEL,(tgtt[]) {
	TGTT_X,13,TGTT_Y,11,
	TGTT_LABEL_TEXT, (tgtt) "Els DNS: ",
	TGTT_END,0
	});

	string1 = tgt_createandlink(window,TGT_CLASS_STRING,(tagitem[]) {
	TGTT_X,28,TGTT_Y,11,TGTT_XS,16,
	TGTT_STRING_MAX,16,
	TGTT_STRING_ACCEPT, (tgtt) "0123456789.",
	TGTT_CALLBACK,(tgtt) nextitem,
	TGTT_END,0	
	});

	tgt_make_nonselectable(string1);
	tgt_refresh(string1);

	label2 = tgt_createandlink(window,TGT_CLASS_LABEL,(tgtt[]) {
	TGTT_X,13,TGTT_Y,12,
	TGTT_LABEL_TEXT, (tgtt) "Msodik DNS: ",
	TGTT_END,0
	});

	string2 = tgt_createandlink(window,TGT_CLASS_STRING,(tagitem[]) {
	TGTT_X,28,TGTT_Y,12,TGTT_XS,16,
	TGTT_STRING_MAX,16,
	TGTT_STRING_ACCEPT, (tgtt) "0123456789.",
	TGTT_CALLBACK,(tgtt) nextitem,
	TGTT_END,0	
	});

	tgt_make_nonselectable(string2);
	tgt_refresh(string2);

	label3 = tgt_createandlink(window,TGT_CLASS_LABEL,(tgtt[]) {
	TGTT_X,13,TGTT_Y,13,
	TGTT_LABEL_TEXT, (tgtt) "Harmadik DNS: ",
	TGTT_END,0
	});

	string3 = tgt_createandlink(window,TGT_CLASS_STRING,(tagitem[]) {
	TGTT_X,28,TGTT_Y,13,TGTT_XS,16,
	TGTT_STRING_MAX,16,
	TGTT_STRING_ACCEPT, (tgtt) "0123456789.",
	TGTT_CALLBACK,(tgtt) nextitem,
	TGTT_END,0	
	});

	tgt_make_nonselectable(string3);
	tgt_refresh(string3);
	
	label5 = tgt_createandlink(window,TGT_CLASS_LABEL,(tgtt[]) {
	TGTT_X,13,TGTT_Y,15,
	TGTT_LABEL_TEXT, (tgtt) "Hostname: ",
	TGTT_END,0
	});

	string5 = tgt_createandlink(window,TGT_CLASS_STRING,(tagitem[]) {
	TGTT_X,28,TGTT_Y,15,TGTT_XS,20,
	TGTT_STRING_MAX,20,
	TGTT_CALLBACK,(tgtt) nextitem,
	TGTT_END,0	
	});	

	line = tgt_createandlink(window,TGT_CLASS_LABEL,
	(tgtt[]) {TGTT_X,1,TGTT_Y,20,
	TGTT_LABEL_TEXT, (tgtt) "----------------------------------------------------------------------------",	
	TGTT_END,0});

	b2 = tgt_createandlink(window,TGT_CLASS_BUTTON,(tgtt[]) {
	TGTT_X,58,TGTT_Y,21,
	TGTT_BUTTON_CAPTION, (tgtt) "  Ok  ",
	TGTT_CALLBACK, (tgtt) save_eth,
	TGTT_BG,1,
	TGTT_END });

	b1 = tgt_createandlink(window,TGT_CLASS_BUTTON,(tgtt[]) {
	TGTT_X,16,TGTT_Y,21,
	TGTT_BUTTON_CAPTION, (tgtt) " Vissza ",
	TGTT_CALLBACK, (tgtt) eth_prev,
	TGTT_BG,1,
	TGTT_END });	

}

int eth_main() {

	int n;
	helpnum = 10;

	ethercount=det(ethdevice, ETHERNET_NETWORK_CARD);
	ethercount++;
	for(n=0;n<ethercount;n++) {	ether[n].dhcp=1; }
	
	step_eth();
	
	return(0);
}
