#include <sys/wait.h>
#include <errno.h>
#include "installer.h"
#include "partition.h"

struct tgt_object *line_g, *list_g, *label1_g, *label2_g, *string1_g, *b1_g, *b2_g, *b3_g, *b4_g, *b5_g;
int pack_main();
int root_main();

/* functions */
void grub_prev() {
	
    tgt_unlink(window);
	pack_main();
	tgt_refresh(window);
}

void grub_next() {
	
     tgt_unlink(window);
	 root_main();
	 tgt_refresh(window);	
}


void savegrub() {
	int n;
	
	conf = tgt_load_conf(confile);
				
	tgt_get(list_g,TGTT_LIST_SELECTED,(tgtt*) &n);
	
	 tgt_set_conf(conf,"grub","device",hddparts[n].hdddev);
	 tgt_save_conf(conf,confile);
	 tgt_unload_conf(conf); 
	 
	 grub_next();
	 
}

void uhupart() {
	char *use, tmp[200], tmp2[200];
	int ksize;
	
	conf = tgt_load_conf(confile);
	
	use = tgt_get_conf(conf,"part2","rootpart","default");
	
	if ( (strcmp(use,"default")) ) { 
	 sprintf(tmp,"%s",use);
	 ksize = strlen(tmp);
	 ksize = ksize - 4;
	 tmp[ksize] = '\0';
	 
	 sprintf(tmp2,"%spart2",tmp);
	 tgt_set_conf(conf,"grub","device",tmp2);
	 tgt_save_conf(conf,confile);
	 tgt_unload_conf(conf);
	
	} else {
	
	  use = tgt_get_conf(conf,"part3","root","default");
	   
	   if ( (strcmp(use,"default")) ) {
	    tgt_set_conf(conf,"grub","device",use);
	    tgt_save_conf(conf,confile);
		tgt_unload_conf(conf);
	   } 
	} 
	
	grub_next();

}


int listfill_g(void **d, int c, int n, char *tmp, int k, int a) {
	
	if(c == TGT_LISTREQ_GETMAX) {
	 return(db);	
	} else {
	 snprintf(tmp,k,hddparts[n].hddname,hddparts[db].hddname); 
	 if ( a == 1 ) { selectedhdd = n; }
	}
	
	return(1);
}

void b_window() {
	int k,c,s;
	char t[100];
	k = tgt_easyrequest(window,"Bootfloppy","Helyezz be egy lemezt. A lemezen az sszes adat el fog veszni.","[ Ok ] |[ Megse ]");	
	if ( !k ) { c = system("/usr/sbin/make-bootfloppy 2>/dev/null>&1 > /dev/null"); 
	 if ( c == -1 ) { tgt_easyrequest(window,"Bootfloppy","Hiba trtent!","[ Ok ]"); }
	 else {  
	 s = WEXITSTATUS(c);
	 sprintf(t,"%s",strerror(s));
	 tgt_easyrequest(window,"Bootfloppy",t,"[ Ok ]");
	 }  	
	}  
}

int step_grub () {
	
	window = tgt_createobject(
	TGT_CLASS_WINDOW, (tgtt[]) {
	TGTT_WINDOW_TITLE, (tgtt) "UHU LINUX - Grub telepitese",
	TGTT_WINDOW_TITLECOLOR,3,
	TGTT_WINDOW_BORDERCOLOR,3,
	TGTT_CALLBACK, (tgtt) hotkeys,
	TGTT_XS, 78, TGTT_YS, 23,	
	TGTT_END,0 
	});
	
	tgt_set(window, TGTT_X, (tgt_getterminal()->x_size - 78) / 2);
	tgt_set(window, TGTT_Y, (tgt_getterminal()->y_size - 23) / 2);	
	
	tgt_link(window,desktop);
	
	list_g = tgt_createandlink(window,TGT_CLASS_LIST,(tgtt[]) {
	TGTT_X,2,TGTT_Y,2,TGTT_XS,74,TGTT_YS,8,
	TGTT_LIST_ACTIVEBG,1,
	TGTT_LIST_FRAMECOLOR,3,
	TGTT_ID,1000,
	TGTT_LIST_DATACALLBACK, (tgtt) listfill_g,
	TGTT_END,0});
	
	b4_g = tgt_createandlink(window,TGT_CLASS_BUTTON,(tgtt[]) {
	TGTT_X,18,TGTT_Y,10,
	TGTT_BUTTON_CAPTION, (tgtt) " Az UHU partcira telepljn a GRUB ",
	TGTT_CALLBACK, (tgtt) uhupart,
	TGTT_BG,1,
	TGTT_END });
	
	b5_g = tgt_createandlink(window,TGT_CLASS_BUTTON,(tgtt[]) {
	TGTT_X,24,TGTT_Y,12,
	TGTT_BUTTON_CAPTION, (tgtt) " Ne telepljn a GRUB ",
	TGTT_CALLBACK, (tgtt) grub_next,
	TGTT_BG,1,
	TGTT_END });
	
	b3_g = tgt_createandlink(window,TGT_CLASS_BUTTON,(tgtt[]) {
	TGTT_X,25,TGTT_Y,14,
	TGTT_BUTTON_CAPTION, (tgtt) " Bootlemez ksztse ",
	TGTT_CALLBACK, (tgtt) b_window,
	TGTT_BG,1,
	TGTT_END });
	
	label1_g = tgt_createandlink(window,TGT_CLASS_LABEL,
	(tgtt[]) {TGTT_X,2,TGTT_Y,16,
	TGTT_LABEL_TEXT, (tgtt) "Alap esetben a kivlasztott merevlemez MBR terletere telepl a GRUB.",	
	TGTT_FG,6,
	TGTT_END,0});
	
	line_g = tgt_createandlink(window,TGT_CLASS_LABEL,
	(tgtt[]) {TGTT_X,1,TGTT_Y,20,
	TGTT_LABEL_TEXT, (tgtt) "----------------------------------------------------------------------------",	
	TGTT_END,0});
	
	b2_g = tgt_createandlink(window,TGT_CLASS_BUTTON,(tgtt[]) {
	TGTT_X,58,TGTT_Y,21,
	TGTT_BUTTON_CAPTION, (tgtt) "  Ok  ",
	TGTT_CALLBACK, (tgtt) savegrub,
	TGTT_BG,1,
	TGTT_END });
	
	b1_g = tgt_createandlink(window,TGT_CLASS_BUTTON,(tgtt[]) {
	TGTT_X,16,TGTT_Y,21,
	TGTT_BUTTON_CAPTION, (tgtt) " Vissza ",
	TGTT_CALLBACK, (tgtt) grub_prev, 
	TGTT_BG,1,
	TGTT_END });
	
	return(0);
	
}

/* main */
int grub_main () {
	helpnum = 11;
	getdevs();
	getmodelsname(); 
		
	step_grub();
	
	return(0);
	 
}
