#include <linux/pci_ids.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <unistd.h>
#include "det.h"
#include "xconfig.h"
#include "installer.h"

#define PMODE 0644

struct tgt_object *popmod, *checkb1, 
				*string1, *string2, *string3, *string4, 
				*modl, *warn;
				
struct tgt_object *drivs, *depth, *reso,
	*labeldrivs, *labeldepth, *labelmonitor, *labelmname, *labelcard, *labelmcard, 
	*labelvideo, *labelvideomem, *labelhs,
	*labelhsync, *labelvs, *labelvsync, *labelres,
	*stringhs1, *stringhs2, *stringvs1, *stringvs2;
					
char savemod[10][120];
int xdb = 0, runxtest = 0; 
void savedata();
struct pci_device_array videocard[100];

int preinst1_main();
int user_main();

/* functions */
void xconfig_prev() {
	tgt_unlink(window);
	user_main();
	tgt_refresh(window);
}

void xconfig_next() {
	tgt_unlink(window);
	preinst1_main();
	tgt_refresh(window);
}

void ddcinf() {

	FILE *file;
	char *ttt;
		
	if ( (file = popen("/usr/sbin/ddcinfo","r")) ) { 

	fgets(ddcinfo.mname,200,file);
	ttt = strchr(ddcinfo.mname,'\n'); *ttt = '\0'; ttt++;
	if ( strlen(ddcinfo.mname) == 0 ) { sprintf(ddcinfo.mname,"Ismeretlen"); } 
	fgets(ddcinfo.mserial,200,file);
	ttt = strchr(ddcinfo.mserial,'\n'); *ttt = '\0'; ttt++;
	if ( strlen(ddcinfo.mserial) == 0 ) { sprintf(ddcinfo.mserial,"Ismeretlen"); } 
	fgets(ddcinfo.mother,200,file);
	ttt = strchr(ddcinfo.mother,'\n'); *ttt = '\0'; ttt++;
	if ( strlen(ddcinfo.mother) == 0 ) { sprintf(ddcinfo.mother,"Ismeretlen"); } 
	fgets(ddcinfo.hsyncmin,200,file);
	ttt = strchr(ddcinfo.hsyncmin,'\n'); *ttt = '\0'; ttt++;
	if ( strlen(ddcinfo.hsyncmin) == 0 ) { sprintf(ddcinfo.hsyncmin,"30"); }
	fgets(ddcinfo.hsyncmax,200,file);
	ttt = strchr(ddcinfo.hsyncmax,'\n'); *ttt = '\0'; ttt++;
	if ( strlen(ddcinfo.hsyncmax) == 0 ) { sprintf(ddcinfo.hsyncmax,"70"); }
	fgets(ddcinfo.vsyncmin,200,file);
	ttt = strchr(ddcinfo.vsyncmin,'\n'); *ttt = '\0'; ttt++;
	if ( strlen(ddcinfo.vsyncmin) == 0 ) { sprintf(ddcinfo.vsyncmin,"50"); }
	fgets(ddcinfo.vsyncmax,200,file);
	ttt = strchr(ddcinfo.vsyncmax,'\n'); *ttt = '\0'; ttt++;
	if ( strlen(ddcinfo.vsyncmax) == 0 ) { sprintf(ddcinfo.vsyncmax,"80"); }
	fgets(ddcinfo.horyzsize,200,file);
	ttt = strchr(ddcinfo.horyzsize,'\n'); *ttt = '\0'; ttt++;
	if ( strlen(ddcinfo.horyzsize) == 0 ) { sprintf(ddcinfo.horyzsize,"Ismeretlen"); } 
	fgets(ddcinfo.vertsize,200,file);
	ttt = strchr(ddcinfo.vertsize,'\n'); *ttt = '\0'; ttt++;
	if ( strlen(ddcinfo.vertsize) == 0 ) { sprintf(ddcinfo.vertsize,"Ismeretlen"); } 
	fgets(ddcinfo.videomem,200,file);
	ttt = strchr(ddcinfo.videomem,'\n'); *ttt = '\0'; ttt++;
	if ( strlen(ddcinfo.videomem) == 0 ) { sprintf(ddcinfo.videomem,"Ismeretlen"); } 
	fgets(ddcinfo.oemname,200,file);
	ttt = strchr(ddcinfo.oemname,'\n'); *ttt = '\0'; ttt++;
	if ( strlen(ddcinfo.oemname) == 0 ) { sprintf(ddcinfo.oemname,"Ismeretlen"); } 
	fgets(ddcinfo.vendorname,200,file);
	ttt = strchr(ddcinfo.vendorname,'\n'); *ttt = '\0'; ttt++;
	if ( strlen(ddcinfo.vendorname) == 0 ) { sprintf(ddcinfo.vendorname,"Ismeretlen"); } 
	fgets(ddcinfo.productname,200,file);
	ttt = strchr(ddcinfo.productname,'\n'); *ttt = '\0'; ttt++;
	if ( strlen(ddcinfo.productname) == 0 ) { sprintf(ddcinfo.productname,"Ismeretlen"); }
	fgets(ddcinfo.productrevision,200,file);
	ttt = strchr(ddcinfo.productrevision,'\n'); *ttt = '\0'; ttt++;
	if ( strlen(ddcinfo.productrevision) == 0 ) { sprintf(ddcinfo.productrevision,"Ismeretlen"); } 
	
	 
	} else { fprintf(stderr,"Nem tudtam futtatni a ddcinfot!\n"); off(); }
	pclose(file);
	
	sprintf(hsync,"%s-%s",ddcinfo.hsyncmin,ddcinfo.hsyncmax);
	sprintf(vsync,"%s-%s",ddcinfo.vsyncmin,ddcinfo.vsyncmax);
	
}

void getdrivername() {
	int i = 0, count;
	
	count = det(videocard,PCI_CLASS_DISPLAY_VGA);  
				
	while (1) {
	 if ( strcmp(videocard[0].module,drs[i]) == 0) {
	  di = i; break; }
	 i++; 
	}
} 

float videogen(float hr, float vr, float s_rr) {
	
	float		dcf;
	float		rr,hsf,vtick;
	float		hfront,hsync,hblank,hfl,vfront,vsync,vback,vblank,vfl;
	
	const	float	hfrontmin	= 0.50;
	const   float   hsyncmin	= 1.20;
	/* const   float   hbackmin	= 1.25; */
	const   float   hblankmin	= 4.00;
	/* const   float   hsfmax		= 60.0; */

	const   float   vfrontmin 	= 0.0;
	const   float   vsyncmin	= 45.0;
	const   float   vbackmin	= 500.0;
	const   float   vblankmin	= 600.0;
	/* const   float   vsfmax 		= 90.0; */

	int    	end = 0;
	int 	v1,v2;
	float	step = 10.0;
	
	hfl = 0.0; vfl = 0.0;
		
	if (s_rr < 20.0) s_rr = 20.0;
	dcf = 1.0;

	do {
	 rr = 1000000.0 * dcf / (hfl * vfl);
	 hsf = 1000.0 * dcf / hfl;

	 hfront = hfrontmin * dcf + hr;
	 if( (int)(hfront) % 8 ) hfront = 8 * (1 + (float)((int)(hfront/8)));

	 hsync = hsyncmin * dcf + hfront;
	 if( (int)(hsync)%8) hsync = 8 * (1 + (float)((int)(hsync/8)));

	 hblank = hblankmin * dcf;
	 hfl = hr + hblank;
	 if( (int)(hfl) % 8 ) hfl = 8 * (1 + (float)( (int)(hfl/8)));

	 vtick = hfl / dcf;
	 vfront = vr + vfrontmin / vtick;

	 vsync = vfront + vsyncmin /vtick;
	 vback = vbackmin /vtick;
	 vblank = vblankmin / vtick;
	
	 vfl = vsync + vback;
	 if( vfl < vr+ vblank) vfl = vr + vblank;

	 v1 = (int)(rr*1000.0);
	 v2 = (int)(s_rr*1000.0);

	 if( v1 == v2 ) end =1;
	 else if( v1 < v2 ) dcf += step;
	 else if( v1 > v2 ) { dcf -= step; step /= 10.0 ;}

   } while( !end );

	/* printf("  Horizontal Resolution:   %4.0f \n",hr);
	printf("  Vertical Resolution:     %4.0f \n",vr);
	printf("  Vertical Refresh Rate:   %4.2f Hz \n",rr);
	printf("  Horizontal Refresh Rate: %4.2f KHz \n",hsf);
	printf("\n"); */
	/* printf("  Dot Clock Frequence:     %4.2f MHz \n",dcf); */
	/* printf("\n"); */
	/* printf(" # V-freq: %4.2f Hz  // h-freq: %4.2f KHz\n Modeline \"%dx%d\" %4.2f  %4d %4d %4d %4d  %4d %4d %4d %4d \n",rr,hsf,(int)(hr),(int)(vr),(dcf),(int)(hr),(int)(hfront),(int)(hsync),(int)(hfl),(int)(vr),(int)(vfront),(int)(vsync),(int)(vfl)); */
	/* exit(0); */ 
	sprintf(modeline,"Modeline \"%dx%d\" %4.2f  %4d %4d %4d %4d  %4d %4d %4d %4d",(int)(hr),(int)(vr),(dcf),(int)(hr),(int)(hfront),(int)(hsync),(int)(hfl),(int)(vr),(int)(vfront),(int)(vsync),(int)(vfl));
	return (hsf); 
	
}

int resok() {
	 char res1[10],res2[10],tmp[1];
	 float a,b,c, vend, x;
	 int i = 0, resp = 0;
	 
	while ( resolution[i] != 0 ) {
	 sscanf(resolution[i],"%[1234567890] %[x] %[1234567890]",res1,tmp,res2); 
	 a = atof(res1);
	 b = atof(res2); 
	 c = 85;
	 vend = videogen(a,b,c);
	 x = atof(ddcinfo.hsyncmax);
	 
	 if (x > vend) { resp = i; } 
	 i++;
	}
	return (resp);
}	

void modgen_quit() {
	tgt_unlink(popmod);
	tgt_destroyobject(popmod);
}

void getmodeline() {
	 char *a,*b,*c;
	 float d,e,f;
	 	 	 	 
	 tgt_get(string1,TGTT_STRING_STRING, (tgtt*) &a);
	 tgt_get(string2,TGTT_STRING_STRING, (tgtt*) &b);
	 tgt_get(string3,TGTT_STRING_STRING, (tgtt*) &c);
	 d = atof(a);
	 e = atof(b);
	 f = atof(c);
	 if (d > 2500 || e > 2500 || f > 200) {
	  tgt_easyrequest(popmod,"Hiba","Tl nagy rtk(ek) !\n\n","[ Ok ]");
	 } else if (!d || !e || !f) {
	  tgt_easyrequest(popmod,"Hiba","Mindhrom mezt tltsd ki !\n\n","[ Ok ]");
	 } else {
	  tgt_set(warn,TGTT_LABEL_TEXT,(tgtt) "");
	  videogen(d,e,f);
	  sprintf(savemod[xdb],"%s #%sHz",modeline,c); 
	  xdb++;
	 }
	 tgt_refresh(popmod);
}

int listfill_mod(void **d, int c, int n, char *tmp, int k, int a) {
	
	if (c == TGT_LISTREQ_GETMAX) {
	 return(xdb);
	} else {
	 snprintf(tmp,k,savemod[n],savemod[xdb]);
	}
	return (1);
}

void listdel_mod(struct tgt_object *list, int n) {
	char temp[10][120];
	int i = 0, j = 0, t;
	
	while ( j != xdb ) {
	 if ( j != n ) { sprintf(temp[i],"%s",savemod[j]); i++; } 
	 j++;
	}
	t = i;
	i = 0;
	while ( i != t) {
	 sprintf(savemod[i],"%s",temp[i]);
	 i++;
	}
	xdb = i;
	tgt_refresh(modl); 
}

/* modeline window */
void modgen() {
	struct tgt_object *b1, *b2;
	
	popmod = tgt_createandlink(desktop,TGT_CLASS_WINDOW, (tgtt[]) {
	TGTT_WINDOW_TITLE, (tgtt) "Modeline generls",
	TGTT_XS,72,TGTT_YS,14,
	TGTT_WINDOW_TITLECOLOR,3,
	TGTT_WINDOW_BORDERCOLOR,3,
	TGTT_CALLBACK, (tgtt) hotkeys,
	TGTT_END,0});
	
	tgt_set(popmod, TGTT_X, (tgt_getterminal()->x_size - 72) / 2);
	tgt_set(popmod, TGTT_Y, (tgt_getterminal()->y_size - 14) / 2);	
	
	tgt_createandlink(popmod,TGT_CLASS_LABEL,
	(tgtt[]) {TGTT_X,2,TGTT_Y,2,
	TGTT_LABEL_TEXT, (tgtt) "Felbonts:",	
	TGTT_END,0});
	
	string1 = tgt_createandlink(popmod,TGT_CLASS_STRING,(tgtt[]) {
	TGTT_X,13,TGTT_Y,2,TGTT_XS,5,
	TGTT_STRING_MAX,5,
	TGTT_STRING_ACCEPT, (tgtt) "1234567890",
	TGTT_CALLBACK,(tgtt) nextitem,
	TGTT_END,0});
	
	tgt_createandlink(popmod,TGT_CLASS_LABEL,
	(tgtt[]) {TGTT_X,18,TGTT_Y,2,
	TGTT_LABEL_TEXT, (tgtt) " x ",	
	TGTT_END,0});
	
	string2 = tgt_createandlink(popmod,TGT_CLASS_STRING,(tgtt[]) {
	TGTT_X,21,TGTT_Y,2,TGTT_XS,5,
	TGTT_STRING_MAX,5,
	TGTT_STRING_ACCEPT, (tgtt) "1234567890",
	TGTT_CALLBACK,(tgtt) nextitem,
	TGTT_END,0});
	
	tgt_createandlink(popmod,TGT_CLASS_LABEL,
	(tgtt[]) {TGTT_X,2,TGTT_Y,3,
	TGTT_LABEL_TEXT, (tgtt) "Vertiklis frissts:",	
	TGTT_END,0});
	
	string3 = tgt_createandlink(popmod,TGT_CLASS_STRING,(tgtt[]) {
	TGTT_X,24,TGTT_Y,3,TGTT_XS,4,
	TGTT_STRING_MAX,4,
	TGTT_STRING_ACCEPT, (tgtt) "1234567890",
	TGTT_CALLBACK,(tgtt) nextitem,
	TGTT_END,0});
	
	warn = tgt_createandlink(popmod,TGT_CLASS_LABEL,
	(tgtt[]) {TGTT_X,2,TGTT_Y,4,
	TGTT_LABEL_TEXT, (tgtt) "",	
	TGTT_FG,1,
	TGTT_END,0}); 
	
	b1 = tgt_createandlink(popmod,TGT_CLASS_BUTTON,(tgtt[]) {
	TGTT_X,30,TGTT_Y,3,
	TGTT_BUTTON_CAPTION, (tgtt) " Mehet ",
	TGTT_CALLBACK, (tgtt) getmodeline,
	TGTT_BG,1,
	TGTT_END,0});
	
	modl = tgt_createandlink(popmod,TGT_CLASS_LIST,(tgtt[]) {
	TGTT_X,1,TGTT_Y,5,
	TGTT_XS,70,TGTT_YS,6,
	TGTT_LIST_ACTIVEBG,1,
	TGTT_LIST_FRAMECOLOR,6,
	TGTT_LIST_DATACALLBACK,(tgtt) listfill_mod,
	TGTT_CALLBACK, (tgtt) listdel_mod,
	TGTT_END,0});
		
	b2 = tgt_createandlink(popmod,TGT_CLASS_BUTTON,(tgtt[]) {
	TGTT_X,32,TGTT_Y,12,
	TGTT_BUTTON_CAPTION, (tgtt) " Ok ",
	TGTT_CALLBACK, (tgtt) modgen_quit,
	TGTT_BG,1,
	TGTT_END,0});
	
	tgt_setfocus(popmod);
	tgt_refresh(desktop);
	
}

/* hsync vsync checkbox */
void hvchange() {
	int c;
	tgt_get(checkb1,TGTT_CHECKBOX_ACTIVE,(tgtt*) &c);
	if (c == 1) {
	 tgt_make_selectable(stringhs1);
	 tgt_set(stringhs1,TGTT_STRING_STRING,(tgtt) "");
	 tgt_make_nonselectable(stringhs2);
	 tgt_set(stringhs2,TGTT_STRING_STRING,(tgtt) "");
	 tgt_make_nonselectable(stringvs1);
	 tgt_set(stringvs1,TGTT_STRING_STRING,(tgtt) "");
	 tgt_make_nonselectable(stringvs2); 
	 tgt_set(stringvs2,TGTT_STRING_STRING,(tgtt) "");
	 tgt_refresh(desktop);
	} else {
	 tgt_make_nonselectable(stringhs1);
	 tgt_make_nonselectable(stringhs2);
	 tgt_make_nonselectable(stringvs1);
	 tgt_make_nonselectable(stringvs2);
	 tgt_refresh(desktop);
	} 
}

int filecopy(char file1[], char file2[]) {

	int f1, f2, n, open(), creat();	
	char buf[BUFSIZ];
	
	if ( (f1 = open(file1, 0)) == -1 ) { printf("nem nyithato meg %s", file1); }
	if ( (f2 = creat(file2, PMODE)) == -1 ) { printf("nem hozhato letre %s", file2); }
	
	while( (n = read(f1, buf, BUFSIZ))>0 ) {
		if( write(f2,buf,n) != n ) { printf("irashiba"); }
	}		
	return(0);
}

void savedata() {
	FILE *file;
	char xf86config[] = { "/tmp/XF86Config-4.tmp" };
	char saveresolution[50] = "\"";
	char *qwe1,*qwe2,*qwe3,*qwe4;
	int tmpint,i,j,a,c;
	struct stat buf;
	
	if ( stat("/tmp/XF86Config-4.tmp",&buf) != -1 ) {  remove(xf86config); }
	filecopy("/usr/share/uhu-console-installer/XF86Config.input","/tmp/XF86Config-4.tmp"); 
	
			
	if ( (file = fopen(xf86config,"a")) ) {
	 
	 tgt_get(depth,TGTT_SELECTBOX_SELECTED,(tgtt*) &tmpint);
	 a = tmpint;
	 fprintf(file,"\n\tDefaultDepth %s\n\n",colors[a]);
	 for (i = 0; i<=a; i++) {
	  fprintf(file,"\tSubSection \"Display\"\n\t\tDepth %s\n",colors[i]);
	 
	  tgt_get(reso,TGTT_SELECTBOX_SELECTED,(tgtt*) &tmpint);
	 
	  for (j = tmpint; j >=0; j--) {
	   strcat(saveresolution,resolution[j]);
	   if ( j != 0 ) { strcat(saveresolution,"\" \""); } 
	   else { strcat(saveresolution,"\""); }
	  }
	   fprintf(file,"\t\tModes %s",saveresolution);
	   fprintf(file,"\n\tEndSubSection\n");
	   sprintf(saveresolution,"\"");
	 }
	 fprintf(file,"EndSection\n\n");
	 
	 fprintf(file,"Section \"Monitor\"\n");
	 fprintf(file,"\tIdentifier \t\"UHU-Monitor\"\n");
	 
	 tgt_get(checkb1,TGTT_CHECKBOX_ACTIVE,(tgtt*) &c);
	 
	 if (c == 1) {
	  tgt_get(stringhs1,TGTT_STRING_STRING,(tgtt*) &qwe1);
	  tgt_get(stringhs2,TGTT_STRING_STRING,(tgtt*) &qwe2);
	  sprintf(hsync,"%s-%s",qwe1,qwe2);
	  tgt_get(stringvs1,TGTT_STRING_STRING,(tgtt*) &qwe3);
	  tgt_get(stringvs2,TGTT_STRING_STRING,(tgtt*) &qwe4);
	  sprintf(vsync,"%s-%s",qwe3,qwe4);	  
	 } else { 
	  sprintf(hsync,"%s-%s",ddcinfo.hsyncmin,ddcinfo.hsyncmax);
	  sprintf(vsync,"%s-%s",ddcinfo.vsyncmin,ddcinfo.vsyncmax);
	 }
	 
	 fprintf(file,"\tHorizSync\t %s\n",hsync);
	 fprintf(file,"\tVertRefresh\t %s\n\n",vsync);
	 
	 for (i = 0; i<xdb; i++) {
	  fprintf(file,"%s\n\n",savemod[i]);
	 }
	 
	 fprintf(file,"EndSection\n\n");
	 
	 fprintf(file,"Section \"Device\"\n");
	 fprintf(file,"\tIdentifier \t\"UHU-Card\"\n");
	 
	 tgt_get(drivs,TGTT_SELECTBOX_SELECTED,(tgtt*) &tmpint);
	 
	 fprintf(file,"\tDriver\t\t \"%s\"\n",drs[tmpint]);
	 fprintf(file,"EndSection\n\n");
	 	 
	 fclose(file);
	 if (!runxtest) { xconfig_next(); }
	} else { popupmsg("Hiba","Nem tudtam megnyitni a tmp filet!\n\n"); off(); }
}

void xtest() {
	runxtest = 1;
	savedata();
	system("xinit /usr/share/uhu-control-center/xfree86-config/testX -- :1 -ac -xf86config /tmp/XF86Config-4.tmp 2>/dev/null>&1");
	runxtest = 0;
}


/* main window */
void step_xconfig () {
	struct tgt_object *line1, *line2, *b1, *b2, *b3, *b4;
	
	window = tgt_createobject(TGT_CLASS_WINDOW, (tgtt[]) {
	TGTT_WINDOW_TITLE, (tgtt) "UHU LINUX - Grafikus fellet",
	TGTT_WINDOW_TITLECOLOR,3,
	TGTT_WINDOW_BORDERCOLOR,3,
	TGTT_CALLBACK, (tgtt) hotkeys,
	TGTT_XS, 78, TGTT_YS, 23,	
	TGTT_END,0 
	});
	
	tgt_set(window, TGTT_X, (tgt_getterminal()->x_size - 78) / 2);
	tgt_set(window, TGTT_Y, (tgt_getterminal()->y_size - 23) / 2);	
	
	tgt_link(window,desktop);
	
	/* driver */
	labeldrivs = tgt_createandlink(window,TGT_CLASS_LABEL,
	(tgtt[]) {TGTT_X,2,TGTT_Y,8,
	TGTT_LABEL_TEXT, (tgtt) "Meghajt:",	
	TGTT_END,0});
	
	drivs = tgt_createandlink(window,TGT_CLASS_SELECTBOX,
	(tagitem[]) {TGTT_X,22,TGTT_Y,8,TGTT_XS,22,
	TGTT_SELECTBOX_ITEMS, (tgtt) drsn,
	TGTT_SELECTBOX_MARK1, (tgtt) "<",
	TGTT_SELECTBOX_MARK2, (tgtt) ">",
	TGTT_END,0});
	
	tgt_set(drivs,TGTT_SELECTBOX_SELECTED,di);

	/* colorbits */
	labeldepth = tgt_createandlink(window,TGT_CLASS_LABEL,
	(tgtt[]) {TGTT_X,2,TGTT_Y,9,
	TGTT_LABEL_TEXT, (tgtt) "Sznmlysg:",	
	TGTT_END,0});
	
	depth = tgt_createandlink(window,TGT_CLASS_SELECTBOX,
	(tagitem[]) {TGTT_X,22,TGTT_Y,9,TGTT_XS,4,
	TGTT_SELECTBOX_ITEMS, (tgtt) colors,
	TGTT_SELECTBOX_SELECTED, (tgtt) 2,
	TGTT_SELECTBOX_MARK1, (tgtt) "<",
	TGTT_SELECTBOX_MARK2, (tgtt) ">",
	TGTT_END,0});
	
	
	/* resolution */
	labelres = tgt_createandlink(window,TGT_CLASS_LABEL,
	(tgtt[]) {TGTT_X,2,TGTT_Y,10,
	TGTT_LABEL_TEXT, (tgtt) "Ajnlott felbonts:",	
	TGTT_END,0});
	
	reso = tgt_createandlink(window,TGT_CLASS_SELECTBOX,
	(tagitem[]) {TGTT_X,22,TGTT_Y,10,TGTT_XS,11,
	TGTT_SELECTBOX_ITEMS, (tgtt) resolution,
	TGTT_SELECTBOX_MARK1, (tgtt) "<",
	TGTT_SELECTBOX_MARK2, (tgtt) ">",
	TGTT_END,0});	
	
	tgt_set(reso,TGTT_SELECTBOX_SELECTED,resi); 
	
	/* monitor */
	labelmonitor = tgt_createandlink(window,TGT_CLASS_LABEL,
	(tgtt[]) {TGTT_X,2,TGTT_Y,2,
	TGTT_LABEL_TEXT, (tgtt) "Monitor:",	
	TGTT_END,0});
	
	labelmname = tgt_createandlink(window,TGT_CLASS_LABEL,
	(tgtt[]) {TGTT_X,18,TGTT_Y,2,
	TGTT_LABEL_TEXT, (tgtt) ddcinfo.mname,	
	TGTT_END,0});
	
	
	/* monitor card */
	labelcard = tgt_createandlink(window,TGT_CLASS_LABEL,
	(tgtt[]) {TGTT_X,2,TGTT_Y,3,
	TGTT_LABEL_TEXT, (tgtt) "Monitor krtya:",	
	TGTT_END,0});
	
	labelmcard = tgt_createandlink(window,TGT_CLASS_LABEL,
	(tgtt[]) {TGTT_X,18,TGTT_Y,3,
	TGTT_LABEL_TEXT, (tgtt) videocard[0].name,	
	TGTT_END,0});
	
	
	/* videomem */
	labelvideo = tgt_createandlink(window,TGT_CLASS_LABEL,
	(tgtt[]) {TGTT_X,2,TGTT_Y,4,
	TGTT_LABEL_TEXT, (tgtt) "Videomem:",	
	TGTT_END,0});
	
	labelvideomem = tgt_createandlink(window,TGT_CLASS_LABEL,
	(tgtt[]) {TGTT_X,18,TGTT_Y,4,
	TGTT_LABEL_TEXT, (tgtt) ddcinfo.videomem,	
	TGTT_END,0});
	
	
	/* hsync */
	labelhs = tgt_createandlink(window,TGT_CLASS_LABEL,
	(tgtt[]) {TGTT_X,2,TGTT_Y,5,
	TGTT_LABEL_TEXT, (tgtt) "Hsync:",	
	TGTT_END,0});

	labelhsync = tgt_createandlink(window,TGT_CLASS_LABEL,
	(tgtt[]) {TGTT_X,18,TGTT_Y,5,
	TGTT_LABEL_TEXT, (tgtt) hsync,	
	TGTT_END,0});
	
	
	/* vsync */
	labelvs = tgt_createandlink(window,TGT_CLASS_LABEL,
	(tgtt[]) {TGTT_X,2,TGTT_Y,6,
	TGTT_LABEL_TEXT, (tgtt) "Vertrefresh:",	
	TGTT_END,0});

	labelvsync = tgt_createandlink(window,TGT_CLASS_LABEL,
	(tgtt[]) {TGTT_X,18,TGTT_Y,6,
	TGTT_LABEL_TEXT, (tgtt) vsync,	
	TGTT_END,0});
	
	
	line1 = tgt_createandlink(window,TGT_CLASS_LABEL,
	(tgtt[]) {TGTT_X,1,TGTT_Y,7,
	TGTT_LABEL_TEXT, (tgtt) "-------------------------------------------------------------------------",	
	TGTT_END,0});
	
	/* hsync, vsync manual change */
	checkb1 = tgt_createandlink(window,TGT_CLASS_CHECKBOX,
	(tgtt[]) {TGTT_X,2,TGTT_Y,12,
	TGTT_CHECKBOX_CAPTION, (tgtt) "Hsyc, vertrefresh megvltoztatsa",
	TGTT_CHECKBOX_ACTIVE,0,
	TGTT_CALLBACK, (tgtt) hvchange,
	TGTT_END,0});
	
	tgt_createandlink(window,TGT_CLASS_LABEL,
	(tgtt[]) {TGTT_X,2,TGTT_Y,13,
	TGTT_LABEL_TEXT, (tgtt) "Hsyncmin:",	
	TGTT_END,0});
	
	stringhs1 = tgt_createandlink(window,TGT_CLASS_STRING,(tgtt[]) {
	TGTT_X,12,TGTT_Y,13,TGTT_XS,4,
	TGTT_STRING_MAX,4,
	TGTT_STRING_ACCEPT, (tgtt) "1234567890",
	TGTT_CALLBACK,(tgtt) nextitem,
	TGTT_END,0});
	
	tgt_make_nonselectable(stringhs1);
	
	tgt_createandlink(window,TGT_CLASS_LABEL,
	(tgtt[]) {TGTT_X,20,TGTT_Y,13,
	TGTT_LABEL_TEXT, (tgtt) "Hsyncmax:",	
	TGTT_END,0});
	
	stringhs2 = tgt_createandlink(window,TGT_CLASS_STRING,(tgtt[]) {
	TGTT_X,30,TGTT_Y,13,TGTT_XS,4,
	TGTT_STRING_MAX,4,
	TGTT_STRING_ACCEPT, (tgtt) "1234567890",
	TGTT_CALLBACK,(tgtt) nextitem,
	TGTT_END,0});
	
	tgt_make_nonselectable(stringhs2);
	
	tgt_createandlink(window,TGT_CLASS_LABEL,
	(tgtt[]) {TGTT_X,2,TGTT_Y,14,
	TGTT_LABEL_TEXT, (tgtt) "Vertrefreshmin:",	
	TGTT_END,0});
	
	stringvs1 = tgt_createandlink(window,TGT_CLASS_STRING,(tgtt[]) {
	TGTT_X,12,TGTT_Y,14,TGTT_XS,4,
	TGTT_STRING_MAX,4,
	TGTT_STRING_ACCEPT, (tgtt) "1234567890",
	TGTT_CALLBACK,(tgtt) nextitem,
	TGTT_END,0});
	
	tgt_make_nonselectable(stringvs1);
	
	tgt_createandlink(window,TGT_CLASS_LABEL,
	(tgtt[]) {TGTT_X,20,TGTT_Y,14,
	TGTT_LABEL_TEXT, (tgtt) "Vertrefreshmax:",	
	TGTT_END,0});
	
	stringvs2 = tgt_createandlink(window,TGT_CLASS_STRING,(tgtt[]) {
	TGTT_X,30,TGTT_Y,14,TGTT_XS,4,
	TGTT_STRING_MAX,4,
	TGTT_STRING_ACCEPT, (tgtt) "1234567890",
	TGTT_CALLBACK,(tgtt) nextitem,
	TGTT_END,0});	
	
	tgt_make_nonselectable(stringvs2);
	
	line2 = tgt_createandlink(window,TGT_CLASS_LABEL,
	(tgtt[]) {TGTT_X,1,TGTT_Y,20,
	TGTT_LABEL_TEXT, (tgtt) "----------------------------------------------------------------------------",	
	TGTT_END,0});
	
	/* buttons */
	b3 = tgt_createandlink(window,TGT_CLASS_BUTTON,(tgtt[]) {
	TGTT_X,53,TGTT_Y,17,
	TGTT_BUTTON_CAPTION, (tgtt) " Modeline generls ",
	TGTT_CALLBACK, (tgtt) modgen,
	TGTT_BG,1,
	TGTT_END,0});
	
	b1 = tgt_createandlink(window,TGT_CLASS_BUTTON,(tgtt[]) {
	TGTT_X,16,TGTT_Y,21,
	TGTT_BUTTON_CAPTION, (tgtt) " Vissza ",
	TGTT_CALLBACK, (tgtt) xconfig_prev,
	TGTT_BG,1,
	TGTT_END,0});
	
	b4 = tgt_createandlink(window,TGT_CLASS_BUTTON,(tgtt[]) {
	TGTT_X,33,TGTT_Y,21,
	TGTT_BUTTON_CAPTION, (tgtt) " Teszt ",
	TGTT_CALLBACK, (tgtt) xtest,
	TGTT_BG,1,
	TGTT_END,0});
		
	b2 = tgt_createandlink(window,TGT_CLASS_BUTTON,(tgtt[]) {
	TGTT_X,58,TGTT_Y,21,
	TGTT_BUTTON_CAPTION, (tgtt) "  Ok  ",
	TGTT_CALLBACK, (tgtt) savedata,
	TGTT_BG,1,
	TGTT_END,0});
}

int xconfig_main () {
	helpnum = 9;	
	ddcinf();
	getdrivername();
    resi = resok(); 
	
	step_xconfig();
	
	return(0);	
}
